// DlgConnectWithKey.cpp : implementation file
//

#include "stdafx.h"
#include "zlusedevmanage.h"
#include "DlgConnectWithKey.h"
#include "../ZLDevManage/ZLDevManageDll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern tZLDM_ModifyKey		m_pZLDM_ModifyKey;
extern tZLDM_Random		m_pZLDM_Random;
extern tZLDM_Crypt			m_pZLDM_Crypt;
extern tZLDM_GetKeyCmdType m_pZLDM_GetKeyCmdType;
extern tZLDM_StartSearchDev	m_pZLDM_StartSearchDev;

/////////////////////////////////////////////////////////////////////////////
// CDlgConnectWithKey dialog


CDlgConnectWithKey::CDlgConnectWithKey(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgConnectWithKey::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgConnectWithKey)
	m_ConnectIP = _T("");
	m_ConnectKey = _T("");
	m_ConnectPort = 0;
	m_NewKey = _T("");
	m_OldKey = _T("");
	m_SendData = _T("");
	m_ModifyKeyDevID = _T("");
	//}}AFX_DATA_INIT
	m_ConnectIP = "192.168.1.200";
	m_ConnectPort = 4196;
	m_SendData = "send test.";
	m_ConnectKey = "123456";
	m_NewKey = "123456";
	m_ModifyKeyDevID = "284E2F44FE1B";
}


void CDlgConnectWithKey::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgConnectWithKey)
	DDX_Text(pDX, IDC_CONNECT_IP, m_ConnectIP);
	DDX_Text(pDX, IDC_CONNECT_KEY, m_ConnectKey);
	DDV_MaxChars(pDX, m_ConnectKey, 10);
	DDX_Text(pDX, IDC_CONNECT_PORT, m_ConnectPort);
	DDX_Text(pDX, IDC_NEW_KEY, m_NewKey);
	DDV_MaxChars(pDX, m_NewKey, 10);
	DDX_Text(pDX, IDC_OLD_KEY, m_OldKey);
	DDV_MaxChars(pDX, m_OldKey, 10);
	DDX_Text(pDX, IDC_SEND_DATA, m_SendData);
	DDX_Text(pDX, IDC_MODIFY_KEY_DEV_ID, m_ModifyKeyDevID);
	DDV_MaxChars(pDX, m_ModifyKeyDevID, 12);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgConnectWithKey, CDialog)
	//{{AFX_MSG_MAP(CDlgConnectWithKey)
	ON_BN_CLICKED(ID_CONNECT_WITH_KEY, OnConnectWithKey)
	ON_BN_CLICKED(ID_MODIFY_KEY, OnModifyKey)
	ON_BN_CLICKED(ID_SEND_TEST, OnSendTest)
	ON_BN_CLICKED(ID_AUTH_DEV_VALID, OnAuthDevValid)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgConnectWithKey message handlers

void CDlgConnectWithKey::OnConnectWithKey() 
{
	// OnConnectWithKeyƲ֤豸ϷԵĲ	
	unsigned char recv_buf[KEY_AUTH_BUF_LEN];
	unsigned char send_buf[KEY_AUTH_BUF_LEN];
	unsigned char cryption[KEY_AUTH_CRYPTION_LEN];
	unsigned char id_string[ID_STRING_LEN+1];
	CString str;
	
	UpdateData(TRUE);
	
	m_socket.Close();
	m_socket.Create(0);
	m_socket.Connect(m_ConnectIP, m_ConnectPort);

	Sleep(100);

	// յǺϷ1
	if(m_socket.Receive(recv_buf, KEY_AUTH_BUF_LEN) > 0 
		&& (*m_pZLDM_GetKeyCmdType)(recv_buf) == 1)
	{
		// idڲidӦ
		memcpy(id_string, (recv_buf + KEY_AUTH_POS_ID), ID_STRING_LEN);
		id_string[ID_STRING_LEN] = 0;
		str = id_string;
		
		// յ豸ܽ
		memcpy(cryption, (*m_pZLDM_Crypt)(recv_buf + KEY_AUTH_POS_RANDOM, m_ConnectKey), KEY_AUTH_CRYPTION_LEN);

		// ׼4Ӧ
		memcpy(send_buf, recv_buf, KEY_AUTH_BUF_LEN);
		send_buf[KEY_AUTH_POS_CMD] = 4;					// Ϊ4
		memcpy(send_buf + KEY_AUTH_POS_RANDOM, cryption, KEY_AUTH_CRYPTION_LEN);	// Ӧ

		m_socket.Send(send_buf, KEY_AUTH_BUF_LEN);
		
		// ׼֤
		Sleep(100);

		// յǺϷ5
		if(m_socket.Receive(recv_buf, KEY_AUTH_BUF_LEN) > 0 
			&& (*m_pZLDM_GetKeyCmdType)(recv_buf) == 5)
		{
			// 1Ϊȷ0Ϊ
			if(recv_buf[KEY_AUTH_POS_RANDOM] == 1)
			{
				str += "Authenticate ok!";
				AfxMessageBox(str);
			}
			else
			{
				str += "key fail!";
				AfxMessageBox(str);
			}
		}
		else
		{
			str += "Authenticate fail!";
			AfxMessageBox(str);
		}
		
	}
	else
	{
		AfxMessageBox("key==0, or no key needed");
	}
}

void CDlgConnectWithKey::OnAuthDevValid() 
{
	// OnConnectWithKeyƲ֤豸ϷԵĲ	
	unsigned char recv_buf[KEY_AUTH_BUF_LEN];
	unsigned char send_buf[KEY_AUTH_BUF_LEN];
	unsigned char cryption[KEY_AUTH_CRYPTION_LEN];
	unsigned char random[KEY_AUTH_CRYPTION_LEN];
	unsigned char cryption2[KEY_AUTH_CRYPTION_LEN];
	unsigned char id_string[ID_STRING_LEN+1];
	CString str;
	
	UpdateData(TRUE);
	
	m_socket.Close();
	m_socket.Create(0);
	m_socket.Connect(m_ConnectIP, m_ConnectPort);

	Sleep(100);

	// յǺϷ1
	if(m_socket.Receive(recv_buf, KEY_AUTH_BUF_LEN) > 0 
		&& (*m_pZLDM_GetKeyCmdType)(recv_buf) == 1)
	{
		// idڲidӦ
		memcpy(id_string, (recv_buf + KEY_AUTH_POS_ID), ID_STRING_LEN);
		id_string[ID_STRING_LEN] = 0;
		str = id_string;
		
		// յ豸ܽ
		memcpy(cryption, (*m_pZLDM_Crypt)(recv_buf + KEY_AUTH_POS_RANDOM, m_ConnectKey), KEY_AUTH_CRYPTION_LEN);

#if 1		// #if 1ӵ֤豸Ĳ
		// һdev
		memcpy(send_buf, recv_buf, KEY_AUTH_BUF_LEN);
		send_buf[KEY_AUTH_POS_CMD] = 2;					// Ϊ2
		memcpy(random, (*m_pZLDM_Random)(), KEY_AUTH_CRYPTION_LEN);
		memcpy(send_buf + KEY_AUTH_POS_RANDOM, random, KEY_AUTH_CRYPTION_LEN);	// 
		m_socket.Send(send_buf, KEY_AUTH_BUF_LEN);
		
		// ׼豸2Ӧ
		Sleep(100);

		// յǺϷ3
		if(m_socket.Receive(recv_buf, KEY_AUTH_BUF_LEN) > 0 
			&& (*m_pZLDM_GetKeyCmdType)(recv_buf) == 3)
		{
			// ǵļܽбȽ
			memcpy(cryption2, (*m_pZLDM_Crypt)(random, m_ConnectKey), KEY_AUTH_CRYPTION_LEN);

			if(memcmp(recv_buf + KEY_AUTH_POS_RANDOM, cryption2, KEY_AUTH_CRYPTION_LEN) == 0)
			{
				str += "dev valid!";
				AfxMessageBox(str);
			}
			else
			{
				str += "dev not valid!";
				AfxMessageBox(str);
			}
		}
		else
		{
			str += "dev reply error!";
			AfxMessageBox(str);
		}
#endif
		// ׼4Ӧ
		memcpy(send_buf, recv_buf, KEY_AUTH_BUF_LEN);
		send_buf[KEY_AUTH_POS_CMD] = 4;					// Ϊ4
		memcpy(send_buf + KEY_AUTH_POS_RANDOM, cryption, KEY_AUTH_CRYPTION_LEN);	// Ӧ

		m_socket.Send(send_buf, KEY_AUTH_BUF_LEN);
		
		// ׼֤
		Sleep(100);

		// յǺϷ5
		if(m_socket.Receive(recv_buf, KEY_AUTH_BUF_LEN) > 0 
			&& (*m_pZLDM_GetKeyCmdType)(recv_buf) == 5)
		{
			// 1Ϊȷ0Ϊ
			if(recv_buf[KEY_AUTH_POS_RANDOM] == 1)
			{
				str += "Authenticate ok!";
				AfxMessageBox(str);
			}
			else
			{
				str += "key fail!";
				AfxMessageBox(str);
			}
		}
		else
		{
			str += "Authenticate fail!";
			AfxMessageBox(str);
		}
		
	}
	else
	{
		AfxMessageBox("key==0, or no key needed");
	}
}
void CDlgConnectWithKey::OnModifyKey() 
{
	int ret;
	UpdateData(TRUE);

	// Ƚһ
	(*m_pZLDM_StartSearchDev)();

	// ֤豸бе
	ret = (*m_pZLDM_ModifyKey)(m_ModifyKeyDevID, m_OldKey, m_NewKey);
	if(ret == 0)
	{
		AfxMessageBox("devcie not online!");
	}
	else if(ret == -1)
	{
		AfxMessageBox("old key error!");
	}
	else
	{
		AfxMessageBox("modify success!");
	}
}

void CDlgConnectWithKey::OnSendTest() 
{
	UpdateData(TRUE);
	m_socket.Send(m_SendData, m_SendData.GetLength());
}

